(function() {
	tinymce.create('tinymce.plugins.zdiaporamaPlugin', {
		/**
		* @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
		* @param {string} url Absolute URL to where the plugin is located.
		*/
		init : function(ed, url) {
			// Register the command so that it can be invoked by using tinyMCE.activeEditor.execCommand('mcezdiaporama');
			ed.addCommand('mcezdiaporama', function() {
				ed.windowManager.open({
					file : url + '/zdiaporama.php',
					width : 500 +  parseInt(ed.getLang('zdiaporama.delta_width', 0)),
					height : 460 + parseInt(ed.getLang('zdiaporama.delta_height', 0)),
					inline : 1,
					scrollbars : true
				}, {
					resizable : "yes",
					plugin_url : url, // Plugin absolute URL
				   // some_custom_arg : 'custom arg' // Custom argument
				});
			});
			ed.addCommand('mcezdiaporama_del', function() {
				var node = ed.selection.getNode();
				if (node.nodeName == 'DIV' && node.parentNode.nodeName == 'DIV' && ed.dom.getAttrib(node.parentNode,'zdiaporama')) {
					node = node.parentNode ;
				}
				if (node.nodeName == 'DIV' && ed.dom.getAttrib(node,'zdiaporama')) {
					ed.dom.remove(node);
				}
			});

			// Register zdiaporama button
			ed.addButton('zdiaporama', {
				title : 'zdiaporama : Affiche un diaporama simple',
				cmd : 'mcezdiaporama',
				image : url + '/img/zdiaporama.gif'
			});
			ed.addButton('zdiaporama_del', {
				title : 'zdiaporama : Supprimer le diaporama',
				cmd : 'mcezdiaporama_del',
				image : url + '/img/zdiaporama_del.gif'
			});

			ed.onNodeChange.add(function(ed, cm, n ) {
				ed.dom.removeClass(ed.dom.select('.zdiapo'),'zdiapo_selected');
				var node=n;
				var node = ed.selection.getNode();
				
				if ((node.nodeName == 'DIV') && ((ed.dom.getAttrib(node,'zdiaporama')) || ((node.parentNode.nodeName == 'DIV') && (ed.dom.getAttrib(node.parentNode,'zdiaporama'))))) {
					cm.setActive('zdiaporama', true);
					cm.setActive('zdiaporama_del', true);
					cm.setDisabled('zdiaporama_del', false);
					if(ed.dom.getAttrib(node,'zdiaporama')){ed.dom.addClass(node,'zdiapo_selected');}
					else{ed.dom.addClass(node.parentNode,'zdiapo_selected');}
				}else{
					cm.setActive('zdiaporama', false);
					cm.setActive('zdiaporama_del', false);
					cm.setDisabled('zdiaporama_del', true);
				}
			});
			
		},
		
        getInfo : function() {
            return {
                longname : 'zdiaporama plugin',
                author : 'Jean-Paul GIAUSSERAND et adaptation pour zdiaporama Gabriel MONTAIGU-LANCELIN',
				authorurl : 'http://www.giausserand.fr/index.php?perma=ziteplus',
				infourl : 'http://www.giausserand.fr/index.php?perma=ziteplus',
				//version : tinymce.majorVersion + "." + tinymce.minorVersion
                version : "1.0"
                  };
                }
        });

        // Register plugin
        tinymce.PluginManager.add('zdiaporama', tinymce.plugins.zdiaporamaPlugin);
})(tinymce);