<?php
/*
module:	zdiaporama pour le CMS ziteplus
Cr par Adrien POREAUX
Adaptation pour tinymce par Gabriel MONTAIGU-LANCELIN
Licence : Creative Commons BY-CC-NC-SA

Adapt de : module Gestion album photo de Jean-Paul GIAUSSERAND (http://www.giausserand.fr/index.php?perma=ziteplus)

Ne fonctionne correctement qu' partir de la version 0.9.2rc2 de Ziteplus.

-----------
 versions :
-----------
v1.4: Adaptation  Ziteplus >= 0.9.5 (jpg)
v1.3: Image de dpart diffrente  chaque excution. Si la rubrique est vide ou n'existe pas, ne rien afficher.
v1.2: Intgration  l'diteur Tinymce via un plugin. Modification automatique de tinymce.php  l'installation. Adaptation  la nouvelle structure de fichiers de ziteplus 0.9.2. Centrage vertical et horizontal du diaporama. Ne casse pas les design extensibles aux petites rsolutions. Correction de bugs divers.
v1.1: Ajout de l'argument float et remplacement de toutes les occurences de "catgorie" par "Rubrique" pour coller au vocabulaire du CMS.
v1.0: Initial

--------------
 Description :
--------------
Ce module permet de simplement faire dfiler les images d'une Rubrique dans le CMS ziteplus.
Il se compose d'un plugin tinymce et du script php ziteplus prsent.
Il utilise les fonctionnalits de gestion de plugins de ziteplus pour modifier automatiquement les fichiers de configuration lors de son installation ou sa dsinstallation.

Ce script php intgre le code javascript dans le header de la page via les fonctions du CMS, et il intgre le code html  l'endroit o ce module est appel dans la page.
Chaque variable et fonction javascript est prfixe du nom de la Rubrique et d'un numro. On peut donc mettre plusieurs diaporamas dans une page.

Le plugin tinymce se charge lui d'insrer l'appel au code php dans la page, encadr par deux <div> contenant le style css choisi; le code php crant uniquement le <img /> encadr d'un <div> et les scripts dans le header de la page.

--------------
 Utilisation : 
-------------- 
Via le plugin de tinymce, renseigner le nom de la rubrique, et ventuellement d'autres informations du style taille, marges...

En rsum, on obtient dans la page le code suivant:
<div class="zdiapo zdiapo_RUBRIQUE"> <div> <div> <span> </span> <img class="zdiapo_RUBRIQUE_1" /> </div> </div> </div>
La succession de <div> est importante car il y a des styles css empils.

On peux ainsi prendre en charge par css
- Tous les diaporamas par un                                .zdiapo
- Tous les diaporamas d'une page particulire par un        #pg_mapage .zdiapo
- Un diaporama en particulier par un                        .zdiapo_RUBRIQUE
etc selon votre niveau en css...

Plus prcisment, le code gnr est le suivant :

<div zdiaporama="RUBRIQUE" class="zdiapo zdiapo_RUBRIQUE" style="...">
//style css intgr dans le div par tinymce:
float : $fl;
width : $wmax %;
max-width : $w px;
max-height : $h px;
padding-left : $pl px;
padding-right: $pr px; 
padding-top: $pt px; 
padding-bottom: $pb px; 
font-size: 0;

	<div style="...">
	//style intgr dans le div par tinymce
	position : relative;
	padding-top : $ratio %;
	
		<div>
		//style insr une seule fois par le script php dans le header de la page (div.zdiapo div div)
		position : absolute;
		top : 0;
		bottom : 0;
		left : 0;
		right : 0;
		text-align : center;
		
			<span>
			//style insr dans le span par le script php
			display : inline-block;
			vertical-align : middle;
			height : 100%;
			</span>
			
			<img class="zdiapo zdiapo_RUBRIQUE zdiapo_RUBRIQUE_NUMERO">
			//style insr dans le header de la page via le script php (img.zdiapo_RUBRIQUE_NUMERO)
			max-height : 100%;
			max-width : 100%;
			display : inline;
			margin : auto;
			vertical-align : middle;
			</img>
		</div>
	</div>
</div>
		

------------------------------------------
Ce qui suit est donn pour info uniquement, car tout est gr automatiqument par le plugin de tinymce :
------------------------------------------

Syntaxe du code php:
<?php echo $this->page_module("zdiaporama","ng=Rubrique1&h=256&w=256&wmax=50&ratio=100&t=5&fl=right&clear=true&pl=5&pr=5&pt=5&pb=5")?>

Il n'y a pas d'ordre obligatoire pour les arguments. Ils sont tous facultatifs, sauf 'ng'. Le plugin de tinymce les insre tous par commodit.

Arguments:
ng = Rubrique des images  faire dfiler. Argument obligatoire.
h = hauteur max de l'image. Dfini dans un <style> intgr au HTML. Si 0 pas de <style> (permet d'utiliser un CSS perso plus prcis). Si absent, par dfaut 256px. Exprim en px.
w = largeur max de l'image. Idem.
wmax = largeur max de l'image exprime en % de la largeur du div parent. Permet de rduire automatiquement la largeur du diaporama si utilisation d'un design extensible avec des petites rsolutions d'cran. Non gr par le script php, uniquement par tinymce.
ratio = ratio h/w exprim en %. Calcul automatiquement par tinymce. Paramtre technique important pour adaptation aux petites rsolutions. Non gr par le script php, uniquement par tinymce.
t = dlai en seconde entre deux images. Si absent, par dfaut 5 sec. Doit tre >0.
fl = attribut css "float" du div. Dfini dans un <style> intgr au HTML. Accepte "left", "right" et "none". Si absent pas de <style>, permet d'utiliser un css perso. Ce paramtre est dsormais dsactiv car ceci est gr par le plugins de tinymce.
clear = boolen qui gre l'insertion d'un clear:left ou clear:right dans le css. Non gr par le script php, gr par tinymce.
pl, pr, pt, pb = valeur du padding autour de l'image. Ceci est dsormais gr par le plugin de tinymce, aussi ce paramtre est dsactiv.

*/

class Tzdiaporama extends Tmodule
{
	protected function Register() {
		self::$cms->register_event(eOption,eAfter,$this->modulename);
	}
	function EventX(Tmodule &$src,$event,$mode,&$out,$opt=null) {
		if ($event==eOption && $mode==eAfter && self::$cms->truepage && (class_exists('Tpage_admin')==true)  && ($src->modulename!=$this->modulename)){
			if ($opt=='content_css'){
				// Prendre en compte le css de zdiaporama
				$out .= (empty($out)?'':',').'tinymce/plugins/zdiaporama/css/extended_content.css';
			} else if ($opt=='n_plugins'){
				$out = array_merge(array_diff($out,array('n_plugins')),array('zdiaporama','zdiaporama_del'));
 			} else if ($opt=='a_plugins'){
				$out = array_merge(array_diff($out,array('a_plugins')),array($this->modulename));
			}	

			
		}
	}
	function dojob($opt="")
	{
		parent::dojob();
		static $zdiapo= array();
		$zprubs = new Trubs(self::$cms->cpath.'/rubs.dta');
		require_once(self::$cms->zpath.'/tdocs.php');
		$docs = new Tdocs(self::$cms->cpath.'/docs.dta');
		$docs->sort();
		parse_str($opt, $param); // Prendre valeur des paramtres
		$out='';
		$a='';
		$rub = preg_replace("/[^a-zA-Z0-9]/", "", $param['ng']); // Nom de la rubrique sans caractres spciaux
		
		if (isset($zdiapo[$rub])) //Identificateur unique du diaporama
		{
			$zdiapo[$rub]++;
		}else{
			$zdiapo[$rub] = 1;
		}
		
		// Le module ne peut tre appel qu'une fois par Rubrique et par page (sinon le script ne s'excute pas, je ne sais pas pourquoi)
		// BUG RESOLU, donc condition toujours vraie.
		//if (true)
		//{
//			$zdiapo[$rub] = 1;
			
		// On met dans $liste[] les images de la Rubrique $param['ng']
		foreach ($docs as $docname => $doc) 
		{
			if ($docs->isDocAuth($docname) && !empty($doc[cDocRub]) &&  (in_array($param['ng'],$doc[cDocRub])) &&($doc[cDocType]=='img')) 
			{
				$liste[] = rawurlencode($docname);
			}
		}
		
		//On vrifie que $liste contient au moins un lment, sinon on annule tout
		if (!empty($liste))
		{
			// On vrifie que les param numriques contiennent bien un nombre et pas du texte, dans le cas o le code php n'a pas t insr par tinymce
//			if (!preg_match('#^[0-9]*$#',$param['h'])) {$param['h']='';}
//			if (!preg_match('#^[0-9]*$#',$param['w'])) {$param['w']='';}
			if (!preg_match('#^[0-9]*$#',$param['t'])) {$param['t']='';}
//			if (!preg_match('#^[0-9]*$#',$param['pl'])) {$param['pl']='';} //Gr par tinymce dsormais
//			if (!preg_match('#^[0-9]*$#',$param['pr'])) {$param['pr']='';}
//			if (!preg_match('#^[0-9]*$#',$param['pt'])) {$param['pt']='';}
//			if (!preg_match('#^[0-9]*$#',$param['pb'])) {$param['pb']='';}
			
			self::$cms->content['dftcss'].="img.zdiapo_".$rub."_".$zdiapo[$rub]." { ";
			/*Annulation car gr par tinymce
			if (isset($param['h'])&&$param['h']!='')
			{
				if($param['h']==0)
				{
				}else{
					self::$cms->content['dftcss'].="max-height :".$param['h']."px; ";// rajout px ici pour integration tinymce
				}
			}else{
				self::$cms->content['dftcss'].="max-height :256px; ";
			}
			if (isset($param['w'])&&$param['w']!='')
			{
				if($param['w']==0)
				{
				}else{
					self::$cms->content['dftcss'].="max-width :".$param['w']."px; ";
				}
			}else{
				self::$cms->content['dftcss'].="max-width :256px; ";
			}*/
			self::$cms->content['dftcss'].="max-height:100%; max-width:100%; display:inline; margin:auto; vertical-align:middle; ";
			/*Annulation car intgration dans le js de tinymce
			self::$cms->content['dftcss'].="} .zdiapo".$rub.$zdiapo[$rub]." { ";
			if (isset($param['h']))
			{
				if($param['h']==0)
				{
				}else{
					self::$cms->content['dftcss'].="height :".$param['h']."px; ";
				}
			}else{
				self::$cms->content['dftcss'].="height :256px; ";
			}
			if (isset($param['w']))
			{
				if($param['w']==0)
				{
				}else{
					self::$cms->content['dftcss'].="width :".$param['w']."px; ";
				}
			}else{
				self::$cms->content['dftcss'].="width :256px; ";
			}
			if (isset($param['fl']))
			{
				if($param['fl']=='left')
				{
					self::$cms->content['dftcss'].="float :left; ";
				}elseif($param['fl']=='right'){
					self::$cms->content['dftcss'].="float :right; ";
				}elseif($param['fl']=='none'){
					self::$cms->content['dftcss'].="float :none; ";
				}
			}
			// rajout du padding
			 if (isset($param['pl'])&&$param['pl']!='')
				{
					self::$cms->content['dftcss'].="padding-left :".$param['pl']."px; ";
				}
			 if (isset($param['pr'])&&$param['pr']!='')
				{
					self::$cms->content['dftcss'].="padding-right :".$param['pr']."px; ";
				}
			if (isset($param['pt'])&&$param['pt']!='')
				{
					self::$cms->content['dftcss'].="padding-top :".$param['pt']."px; ";
				}
			if (isset($param['pb'])&&$param['pb']!='')
				{
					self::$cms->content['dftcss'].="padding-bottom :".$param['pb']."px; ";
				}*/
			// fin padding
			self::$cms->content['dftcss'].="}";
			
			self::$cms->content['dftcss'].="div.zdiapo div div {".
			"position : absolute;".
			"top : 0; bottom : 0; left : 0; right : 0;".
			"text-align : center".
			"}";
			
			// On inclut le code javascript dans le head via la fonction du CMS.		 
			self::$cms->content['js'].='<script language="javascript" type="text/javascript">
';
			if (isset($param['t']))
			{
				if($param['t']>0)
				{
					self::$cms->content['js'].='var zdiapo_'.$rub.'_'.$zdiapo[$rub].'_timeDelay = '.$param['t'].';';
				}else{
					self::$cms->content['js'].='var zdiapo_'.$rub.'_'.$zdiapo[$rub].'_timeDelay = 5;';
				}
			}else{
				self::$cms->content['js'].='var zdiapo_'.$rub.'_'.$zdiapo[$rub].'_timeDelay = 5;';
			}
			self::$cms->content['js'].='
var zdiapo_'.$rub.'_'.$zdiapo[$rub].'_Pix = new Array(';
			foreach ($liste as $image)
			{
				$a.='
	"view.php/'.$image.'",';
			}
			self::$cms->content['js'].= rtrim($a, ",");//on vire la dernire virgule
			self::$cms->content['js'].=");\n";
				//Contenu de content['js'] :
				//("view.php/mon_image_01.jpg",
				//"view.php/mon_image_02.jpg",
				//"view.php/mon_image_03.jpg", 
				//"view.php/mon_image_04.jpg");
				
			self::$cms->content['js'].='var zdiapo_'.$rub.'_'.$zdiapo[$rub].'_howMany = zdiapo_'.$rub.'_'.$zdiapo[$rub].'_Pix.length;'."\n".
				'zdiapo_'.$rub.'_'.$zdiapo[$rub].'_timeDelay *= 1000;'."\n".
				'var zdiapo_'.$rub.'_'.$zdiapo[$rub].'_PicCurrentNum = '.mt_rand(0,count($liste)-1).';'."\n".
				'var zdiapo_'.$rub.'_'.$zdiapo[$rub].'_PicCurrent = new Image();'."\n".
				'zdiapo_'.$rub.'_'.$zdiapo[$rub].'_PicCurrent.src = zdiapo_'.$rub.'_'.$zdiapo[$rub].'_Pix[zdiapo_'.$rub.'_'.$zdiapo[$rub].'_PicCurrentNum];'."\n";
			self::$cms->content['js'].='function zdiapo_'.$rub.'_'.$zdiapo[$rub].'_startzdiapo() {'."\n".
				'	setTimeout("zdiapo_'.$rub.'_'.$zdiapo[$rub].'_slideshow()", zdiapo_'.$rub.'_'.$zdiapo[$rub].'_timeDelay);'."\n".
				'}'."\n".
				'function zdiapo_'.$rub.'_'.$zdiapo[$rub].'_slideshow() {'."\n".
				'	zdiapo_'.$rub.'_'.$zdiapo[$rub].'_PicCurrentNum++;'."\n".
				'	if (zdiapo_'.$rub.'_'.$zdiapo[$rub].'_PicCurrentNum == zdiapo_'.$rub.'_'.$zdiapo[$rub].'_howMany) {'."\n".
				'		zdiapo_'.$rub.'_'.$zdiapo[$rub].'_PicCurrentNum = 0;'."\n".
				'	}'."\n".
				'	zdiapo_'.$rub.'_'.$zdiapo[$rub].'_PicCurrent.src = zdiapo_'.$rub.'_'.$zdiapo[$rub].'_Pix[zdiapo_'.$rub.'_'.$zdiapo[$rub].'_PicCurrentNum];'."\n".
				'	document["zdiapo_'.$rub.'_'.$zdiapo[$rub].'"].src = zdiapo_'.$rub.'_'.$zdiapo[$rub].'_PicCurrent.src;'."\n".
				'}';
			self::$cms->content['js'].='</script>';
			
			// On inclut la balise img dans le html
		   $out.='<div><span style="display:inline-block; vertical-align:middle; height:100%;"></span><img class="zdiapo_'.$rub.'_'.$zdiapo[$rub].'" onload="zdiapo_'.$rub.'_'.$zdiapo[$rub].'_startzdiapo()" name="zdiapo_'.$rub.'_'.$zdiapo[$rub].'" alt="diaporama" src="view.php/'.$liste[mt_rand(0,count($liste)-1)].'"/></div>'; // image alatoire pour les visiteurs qui ont dsactiv javascript
		
		//}
		//fin du code unique
		}

		return $out;		
	}
}
?>